- Cal3D 0.11 API Reference -

Classes | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends | List of all members
cal3d::TiXmlBase Class Referenceabstract

TiXmlBase is a base class for every class in TinyXml. More...

`#include <tinyxml.h>`

Inheritance diagram for cal3d::TiXmlBase:

## Classes

class | StringToBuffer

## Public Member Functions

virtual void | Print (FILE *cfile, int depth) const =0
| All TinyXml classes can print themselves to a filestream.
int | Row () const
| Return the position, in the original source file, of this node or attribute.
int | Column () const
| See Row().

## Static Public Member Functions

static void | SetCondenseWhiteSpace (bool condense)
| The world does not agree on whether white space should be kept or not.
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.

## Protected Types

enum

{
TIXML_NO_ERROR = 0 , TIXML_ERROR , TIXML_ERROR_OPENING_FILE , TIXML_ERROR_OUT_OF_MEMORY ,
TIXML_ERROR_PARSING_ELEMENT , TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME , TIXML_ERROR_READING_ELEMENT_VALUE , TIXML_ERROR_READING_ATTRIBUTES ,
TIXML_ERROR_PARSING_EMPTY , TIXML_ERROR_READING_END_TAG , TIXML_ERROR_PARSING_UNKNOWN , TIXML_ERROR_PARSING_COMMENT ,
TIXML_ERROR_PARSING_DECLARATION , TIXML_ERROR_DOCUMENT_EMPTY , TIXML_ERROR_STRING_COUNT
}

## Protected Member Functions

virtual void | StreamOut (TIXML_OSTREAM *) const =0
virtual const char * | Parse (const char *p, TiXmlParsingData *data)=0

## Static Protected Member Functions

static const char * | SkipWhiteSpace (const char *)
static bool | IsWhiteSpace (int c)
static bool | StreamWhiteSpace (TIXML_ISTREAM *in, TIXML_STRING *tag)
static bool | StreamTo (TIXML_ISTREAM *in, int character, TIXML_STRING *tag)
static const char * | ReadName (const char *p, TIXML_STRING *name)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase)
static const char * | GetEntity (const char *in, char *value)
static const char * | GetChar (const char *p, char *_value)
static void | PutString (const TIXML_STRING &str, TIXML_OSTREAM *out)
static void | PutString (const TIXML_STRING &str, TIXML_STRING *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase)

## Protected Attributes

TiXmlCursor | location

## Static Protected Attributes

static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Friends

class | TiXmlNode
class | TiXmlElement
class | TiXmlDocument

## Detailed Description

TiXmlBase is a base class for every class in TinyXml.

It does little except to establish that TinyXml classes can be printed and provide some utility functions.

In XML, the document and elements can contain other elements and other types of nodes.

    A Document can contain: Element (container or leaf)
                            Comment (leaf)
                            Unknown (leaf)
                            Declaration( leaf )

    An Element can contain: Element (container or leaf)
                            Text    (leaf)
                            Attributes (not on tree)
                            Comment (leaf)
                            Unknown (leaf)

    A Decleration contains: Attributes (not on tree)

## Member Function Documentation

## ◆ Parse()

virtual const char * cal3d::TiXmlBase::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data )

protected pure virtual

Implemented in cal3d::TiXmlDocument.

## ◆ Print()

virtual void cal3d::TiXmlBase::Print | ( | FILE * | cfile,
|  | int | depth ) const

pure virtual

All TinyXml classes can print themselves to a filestream.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implemented in cal3d::TiXmlAttribute, cal3d::TiXmlComment, cal3d::TiXmlDeclaration, cal3d::TiXmlDocument, cal3d::TiXmlElement, cal3d::TiXmlText, and cal3d::TiXmlUnknown.

## ◆ Row()

int cal3d::TiXmlBase::Row | ( |  | ) | const

inline

Return the position, in the original source file, of this node or attribute.

The row and column are 1-based. (That is the first row and first column is 1,1). If the returns values are 0 or less, then the parser does not have a row and column value.

Generally, the row and column value will be set when the TiXmlDocument::Load(), TiXmlDocument::LoadFile(), or any TiXmlNode::Parse() is called. It will NOT be set when the DOM was created from operator>>.

The values reflect the initial load. Once the DOM is modified programmatically (by adding or changing nodes and attributes) the new values will NOT update to reflect changes in the document.

There is a minor performance cost to computing the row and column. Computation can be disabled if TiXmlDocument::SetTabSize() is called with 0 as the value.

See also
  TiXmlDocument::SetTabSize()

## ◆ SetCondenseWhiteSpace()

void cal3d::TiXmlBase::SetCondenseWhiteSpace | ( | bool | condense | ) |

inline static

The world does not agree on whether white space should be kept or not.

In order to make everyone happy, these global, static functions are provided to set whether or not TinyXml will condense all white space into a single space or not. The default is to condense. Note changing this values is not thread safe.

## Member Data Documentation

## ◆ errorString

const char * cal3d::TiXmlBase::errorString

static protected

Initial value:
=
{
"No error",
"Error",
"Failed to open file",
"Memory allocation failed.",
"Error parsing Element.",
"Failed to read Element name",
"Error reading Element value.",
"Error reading Attributes.",
"Error: empty tag.",
"Error reading end tag.",
"Error parsing Unknown.",
"Error parsing Comment.",
"Error parsing Declaration.",
"Error document empty."
}

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlerror.cpp
- tinyxmlparser.cpp

Generated by The Cal3D Team with Doxygen 1.15.0